﻿' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System
Imports System.ServiceModel
Imports System.Security.Principal
Imports System.Threading
Imports System.Windows.Forms


<ServiceContract> _
Friend Interface IMyContract
   <OperationContract(IsOneWay := True)> _
   Sub MyMethod()
End Interface

Friend Class MyService
	Implements IMyContract
   Public Sub MyMethod() Implements IMyContract.MyMethod
	  DisplayIdentities("MyService.MyMethod()")
   End Sub

   Private Shared Sub DisplayIdentities(ByVal caption As String)
	  Dim message As String

	  Dim principal As IPrincipal = Thread.CurrentPrincipal
	  Dim context As ServiceSecurityContext = ServiceSecurityContext.Current
	  If context Is Nothing Then
            message = "Token identity: " & WindowsIdentity.GetCurrent().Name & Environment.NewLine & "Principal identity: " & principal.Identity.GetType().ToString & " with " & (If(principal.Identity.Name = "", "Blank identity", principal.Identity.Name)) & Environment.NewLine & "Security context is null"
	  Else
            message = "Token identity: " & WindowsIdentity.GetCurrent().Name & Environment.NewLine & "Principal identity: " & principal.Identity.GetType().ToString & " with " & (If(principal.Identity.Name = "", "Blank identity", principal.Identity.Name)) & Environment.NewLine & "Security context primary identity: " & context.PrimaryIdentity.GetType().ToString & " with " & (If(context.PrimaryIdentity.Name = "", "Blank identity", context.PrimaryIdentity.Name)) & Environment.NewLine & "Security context Windows identity: " & context.WindowsIdentity.GetType().ToString & " with " & (If(context.WindowsIdentity.Name = "", "Blank identity", context.WindowsIdentity.Name))
	  End If
	  MessageBox.Show(message,caption)
   End Sub
End Class
