﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Windows.Forms
Imports Microsoft.ServiceBus
Imports System.ServiceModel
Imports ServiceModelEx.ServiceBus

<CallbackBehavior(UseSynchronizationContext := False)> _
Partial Friend Class MyClientForm
	Inherits Form
	Implements IMyContractCallback
   Private m_Proxy As MyContractClient

   Public Sub New()
	  InitializeComponent()
	  m_Proxy = New MyContractClient(Me)
	  m_Proxy.SetServiceBusPassword("MyPassword")
   End Sub

   Private Sub OnCallService(ByVal sender As Object, ByVal e As EventArgs) Handles callButton.Click
	  m_Proxy.MyMethod()
   End Sub

   Private Overloads Sub OnClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles MyBase.FormClosed
	  m_Proxy.Close()
   End Sub

   Public Sub OnCallback() Implements IMyContractCallback.OnCallback
	  MessageBox.Show("OnCallback()","MyClient")
   End Sub
End Class
