﻿   ' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net



Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Reflection
Imports System.Diagnostics
Imports System.ServiceModel
Imports Microsoft.ServiceBus
Imports System.Runtime.CompilerServices
Imports System.Security.Cryptography.X509Certificates
Imports System.ServiceModel.Channels

Namespace ServiceModelEx.ServiceBus
   Public Class EventsRelayHost
	   Inherits EventsHost
	  Public Sub New(ByVal singletonInstance As Object, ByVal baseAddress As String)
		  Me.New(singletonInstance,New String(){baseAddress})
	  End Sub

	  Public Sub New(ByVal singletonInstance As Object, ByVal baseAddresses() As String)
		  MyBase.New(singletonInstance,baseAddresses)
	  End Sub

	  Public Sub New(ByVal serviceType As Type, ByVal baseAddress As String)
		  Me.New(serviceType,New String(){baseAddress})
	  End Sub
	  Public Sub New(ByVal serviceType As Type, ByVal baseAddresses() As String)
		  MyBase.New(serviceType,baseAddresses)
	  End Sub


	  <MethodImpl(MethodImplOptions.Synchronized)> _
	  Public Overrides Sub SetBinding(ByVal binding As NetOnewayRelayBinding)
		 Debug.Assert(TypeOf binding Is NetEventRelayBinding)

		 RelayBinding = binding
	  End Sub

	  <MethodImpl(MethodImplOptions.Synchronized)> _
	  Public Overrides Sub SetBinding(ByVal bindingConfigName As String)
		 SetBinding(New NetEventRelayBinding(bindingConfigName))
	  End Sub
	  Protected Overrides Function GetBinding() As NetOnewayRelayBinding
		 Return If(RelayBinding, New NetEventRelayBinding())
	  End Function
   End Class
End Namespace
