' 2009 IDesign Inc.
'Questions? Comments? go to 
'http://www.idesign.net


Imports Microsoft.VisualBasic
Imports System.ServiceModel

Namespace ServiceModelEx
   Public Class InstanceContext(Of T)
	  Private privateContext As InstanceContext
	  Public Property Context() As InstanceContext
		  Get
			  Return privateContext
		  End Get
		  Private Set(ByVal value As InstanceContext)
			  privateContext = value
		  End Set
	  End Property

	  Public Sub New(ByVal callbackInstance As T)
		 Context = New InstanceContext(callbackInstance)
	  End Sub
	  Public Sub ReleaseServiceInstance()
		 Context.ReleaseServiceInstance()
	  End Sub
	  Public ReadOnly Property ServiceInstance() As T
		 Get
			Return CType(Context.GetServiceInstance(), T)
		 End Get
	  End Property
   End Class
End Namespace
